<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/getoptions.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/getoptions.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/getoptions.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> __future__ <span class="py-keyword">import</span> generators</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Processor <span class="py-keyword">import</span> Error</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">import</span> sys</span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/getoptions/CommandLineError.html">CommandLineError</a>(Error): <span class="py-keyword">pass</span></span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/getoptions.html#parse_option">parse_option</a>(arg):</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-string">&quot;&quot;&quot;The required format is '--option[=[arg]]' or 'option=arg'.</span></span>
<a id="line16"></a><span class="lineno">16</span><span class="line"><span class="py-string">    In the former case the optional argument is interpreted as</span></span>
<a id="line17"></a><span class="lineno">17</span><span class="line"><span class="py-string">    a string (only '--option' sets the value to True, '--option='</span></span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="py-string">    sets it to the empty string), in the latter case the argument</span></span>
<a id="line19"></a><span class="lineno">19</span><span class="line"><span class="py-string">    is evaluated as a python expression.</span></span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="py-string">    Returns (None, None) for non-option argument&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-keyword">if</span> arg.find(<span class="py-string">'='</span>) == -1 <span class="py-keyword">and</span> <span class="py-keyword">not</span> arg.startswith(<span class="py-string">'--'</span>):</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-keyword">return</span> None, None <span class="py-comment"># we are done</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line">    attribute = arg.split(<span class="py-string">'='</span>, 1)</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">    <span class="py-keyword">if</span> len(attribute) == 2:</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        name, value = attribute</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        <span class="py-keyword">if</span> name.startswith(<span class="py-string">'--'</span>):</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">            name = name[2:] <span class="py-comment"># value is a string</span></span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">            <span class="py-keyword">try</span>:</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">                value = eval(value) <span class="py-comment"># it's a python expression</span></span>
<a id="line32"></a><span class="lineno">32</span><span class="line">            <span class="py-keyword">except</span>:</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">                sys.stderr.write(<span class="py-string">&quot;&quot;&quot;an error occured trying to evaluate the value of \'%s\' (\'%s\')</span></span>
<a id="line34"></a><span class="lineno">34</span><span class="line"><span class="py-string">to pass this as a string, please use %s=&quot;'%s'&quot; \n&quot;&quot;&quot;</span>%(name, value, name, value))</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">                sys.exit(-1)</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        name, value = attribute[0][2:], True <span class="py-comment"># flag the attribute as 'set'</span></span>
<a id="line38"></a><span class="lineno">38</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">    <span class="py-keyword">return</span> name, value</span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span>
<a id="line42"></a><span class="lineno">42</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/getoptions.html#get_options">get_options</a>(args, parse_arg = parse_option, expect_non_options = True):</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">    <span class="py-string">&quot;&quot;&quot;provide an iterator over the options in args.</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="py-string">    All found options are stripped, such that args will</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="py-string">    contain the remainder, i.e. non-option arguments.</span></span>
<a id="line46"></a><span class="lineno">46</span><span class="line"><span class="py-string">    Pass each argument to the parse_option function to</span></span>
<a id="line47"></a><span class="lineno">47</span><span class="line"><span class="py-string">    extract the (name,value) pair. Returns as soon as</span></span>
<a id="line48"></a><span class="lineno">48</span><span class="line"><span class="py-string">    the first non-option argument was detected.</span></span>
<a id="line49"></a><span class="lineno">49</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line50"></a><span class="lineno">50</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">    <span class="py-keyword">while</span> args:</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        name, value = parse_arg(args[0])</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">        <span class="py-keyword">if</span> name:</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            args[:] = args[1:]</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            <span class="py-keyword">yield</span> name, value</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">        <span class="py-keyword">elif</span> <span class="py-keyword">not</span> expect_non_options:</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">            <span class="py-keyword">raise</span> CommandLineError(<span class="py-string">&quot;expected option, got '%s'&quot;</span>%args[0])</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line60"></a><span class="lineno">60</span>
<a id="line61"></a><span class="lineno">61</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
